<?php
//##copyright##

$plugin = 'gmap';
$fields = array('zipcode', 'country', 'state', 'city', 'address', 'latitude', 'longitude');
$length = 64;
$pages = array(
	'members' => array('profile', 'view_member'),
	'autos' => array('autos_add', 'autos_edit', 'autos_view'),
	'articles' => array('submit_article', 'edit_article', 'view_article'),
	//'estates' => array('estate_submit', 'estate_edit'),
	'listings' => array('add_listing', 'edit_listing', 'view_listing'),
	'ypages' => array('ypage_add', 'ypage_edit', 'ypage_view')
);

$iaItem = $iaCore->factory('item');
$iaField = $iaCore->factory('field');

foreach ($data as $item)
{
	$itemname = $item['item'];
	$package = $iaItem->getPackageByItem($itemname);

	switch ($item['action'])
	{
		case '+':
			$group = 0;
			if ($id = $iaDb->one('id', "`item` = '{$itemname}' AND `name` LIKE '%location%'", iaField::getTableGroups()))
			{
				$group = $id;
			}
			else
			{
				$order = $iaDb->one('MAX(`order`) + 1', null, iaField::getTableGroups());
				$group = $iaDb->insert(array(
					'name' => 'location',
					'item' => $itemname,
					'order' => $order,
					'extras' => $package,
					'collapsed' => false,
					'tabview' => 1
				), null, iaField::getTableGroups());
			}

			$sql = sprintf('SHOW COLUMNS FROM `%s%s`', $iaDb->prefix, $itemname);
			$existColumns = array_keys($iaDb->getKeyValue($sql));

			$existFields = $iaDb->onefield('name', "`item` = '$itemname'", null, null, iaField::getTable());
			$order = (int)$iaDb->one('MAX(`order`)', null, iaField::getTable());

			foreach ($fields as $field)
			{
				if (!in_array($field, $existColumns))
				{
					$sql = sprintf('ALTER TABLE `%s%s` ADD `%s` VARCHAR(%d) NOT NULL', $iaDb->prefix, $itemname, $field, $length);
					$iaDb->query($sql);
				}

				if (!in_array($field, $existFields))
				{
					if ('latitude' != $field && 'longitude' != $field)
					{
						$data = array(
							'fieldgroup_id' => $group,
							'name' => $field,
							'item' => $itemname,
							'type' => iaField::TEXT,
							'length' => $length,
							'status' => iaCore::STATUS_ACTIVE,
							'editable' => false,
							'order' => $order++,
							'extras' => $plugin
						);
						$fieldId = $iaDb->insert($data, null, iaField::getTable());

						if (isset($pages[$itemname]))
						{
							foreach ($pages[$itemname] as $page)
							{
								$data = array(
									'page_name' => $page,
									'field_id' => $fieldId,
									'extras' => $package
								);
								$iaDb->insert($data, null, iaField::getTablePages());
							}
						}
					}
				}
				else
				{
					$iaDb->update(array('status' => iaCore::STATUS_ACTIVE), "`name` = '$field' AND `item` = '$itemname'", null, iaField::getTable());
				}
			}

			break;

		case '-':
			$stmt = sprintf("`item` = '%s' AND `required` = 0 AND `extras` = '%s' AND `name` IN ('%s')", $itemname, $plugin, implode("', '", $fields));
			$iaDb->update(array('status' => iaCore::STATUS_APPROVAL), $stmt, null, iaField::getTable());

			break;
	}
}